## ros-one-class-loader 0.5.0-6noble.20250531.2024

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(class_loader CXX)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(Boost REQUIRED COMPONENTS thread system filesystem)

set(CATKIN_DISABLED false CACHE BOOL "Disable the catkin build, useful if catkin is present but a build outside of ros is done")
if(NOT CATKIN_DISABLED)
  find_package(catkin QUIET)
endif()

find_package(console_bridge REQUIRED)

if(${catkin_FOUND})
  find_package(catkin REQUIRED COMPONENTS cmake_modules)
  find_package(Poco REQUIRED COMPONENTS Foundation)
  catkin_package(
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME} ${Poco_LIBRARIES}
    DEPENDS Boost Poco console_bridge
    CFG_EXTRAS class_loader-extras.cmake
  )
else()
  message("-- catkin not found")
  set(Poco_DIR cmake)
  find_package(Poco REQUIRED COMPONENTS Foundation)
  set(CATKIN_GLOBAL_BIN_DESTINATION bin)
  set(CATKIN_GLOBAL_LIB_DESTINATION lib)
  set(CATKIN_GLOBAL_LIBEXEC_DESTINATION lib)
  set(CATKIN_GLOBAL_INCLUDE_DESTINATION include)
  set(CATKIN_PACKAGE_LIB_DESTINATION ${CATKIN_GLOBAL_LIB_DESTINATION})
  set(CATKIN_PACKAGE_BIN_DESTINATION ${CATKIN_GLOBAL_LIBEXEC_DESTINATION}/${PROJECT_NAME})
  set(CATKIN_PACKAGE_INCLUDE_DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/${PROJECT_NAME})
endif()

include_directories(include ${console_bridge_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
set(${PROJECT_NAME}_HDRS
  include/class_loader/class_loader.hpp
  include/class_loader/class_loader_core.hpp
  include/class_loader/exceptions.hpp
  include/class_loader/meta_object.hpp
  include/class_loader/multi_library_class_loader.hpp
  include/class_loader/register_macro.hpp
)
if(WIN32)
  add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
else()
  add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
endif()

target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
install(DIRECTORY include/class_loader/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(PROGRAMS scripts/class_loader_headers_update.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

if(NOT catkin_FOUND)
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${Boost_LIBRARIES}
    ${console_bridge_LIBRARIES}
    ${Poco_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/${TARGET_NAME}.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.pc @ONLY)

  install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION lib/pkgconfig)
endif()

=== debian/changelog ===
ros-one-class-loader (0.5.0-6noble.20250531.2024) UNRELEASED; urgency=high

  * noble Append timestamp when binarydeb was built.

 -- Michael Carroll <michael@openrobotics.org>  Sat, 31 May 2025 20:24:35 +0000

ros-one-class-loader (0.5.0-0noble) noble; urgency=high

  * Declare specific boost dependencies. (#136 <https://github.com/ros/class_loader/issues/136>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Fri, 07 Feb 2020 00:00:00 -0000

ros-one-class-loader (0.4.2-0noble) noble; urgency=high

  * Add Python 3 support to header update scripts. (#122 <https://github.com/ros/class_loader/issues/122>)
  * Set test dll runtime output to CATKIN_PACKAGE_BIN_DESTINATION on Windows. (#113 <https://github.com/ros/class_loader/issues/113>)
  * Improve warning message formatting and detail. (#108 <https://github.com/ros/class_loader/issues/108>)
  * Add export to variable in order to allow builds on Windows. (#102 <https://github.com/ros/class_loader/issues/102>)
  * Ignore warnings about import/exports when deriving from std classes on MSVC. (#116 <https://github.com/ros/class_loader/issues/116>)
  * Use #pragma message() to print out warnings in MSVC. (#114 <https://github.com/ros/class_loader/issues/114>)
  * Avoid including Poco headers globally. (#115 <https://github.com/ros/class_loader/issues/115>)
  * Make Steven! Ragnarok the maintainer (#107 <https://github.com/ros/class_loader/issues/107>)
  * Fix non-defined CMake variable (forward-port to Melodic). (#97 <https://github.com/ros/class_loader/issues/97>)
  * Contributors: James Xu, Johnson Shih, Markus Grimm, Mikael Arguedas, Robert Haschke

 -- Michael Carroll <michael@openrobotics.org>  Fri, 07 Feb 2020 00:00:00 -0000

ros-one-class-loader (0.4.1-0noble) noble; urgency=high

  * Provide std::shared_ptr interface (#95 <https://github.com/ros/class_loader/issues/95>)
  * Windows compat and style fixups (#90 <https://github.com/ros/class_loader/issues/90>)
    * add visibility macros to public functions
    * rename private namespace 'class_loader_private' to 'impl' to match ros2 branch
  * use new headers to build library (#93 <https://github.com/ros/class_loader/issues/93>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Fri, 27 Apr 2018 00:00:00 -0000

ros-one-class-loader (0.4.0-0noble) noble; urgency=high

  * Stop checking for c++11 support (#87 <https://github.com/ros/class_loader/pull/87>)
    all Melodic targeted platforms use gnu++14 so checking and forcing -std=c++11 doesn't make sense anymore
  * [ABI breaking] use std::string references for exceptions (#86 <https://github.com/ros/class_loader/issues/86>)
  * deprecate .h headers in favor of .hpp headers (#81 <https://github.com/ros/class_loader/pull/81>)
  * provide a script with exhaustive rules for header replacement
  * comply with package format2 xsd (#83 <https://github.com/ros/class_loader/issues/83>)
  * [ABI breaking] Exceptions fixups (#82 <https://github.com/ros/class_loader/issues/82>)
    * inline exceptions
    * use throw statement rather than function
  * [linter] add nolint for global std::string used for testing (#79 <https://github.com/ros/class_loader/issues/79>)
  * use auto for all for loops iterating on vectors/maps (#78 <https://github.com/ros/class_loader/issues/78>)
  * Add systemLibraryFormat and systemLibraryPrefix functions (#77 <https://github.com/ros/class_loader/issues/77>)
  * [ABI breaking] Bring melodic-devel closer to ros2 branch (#76 <https://github.com/ros/class_loader/issues/76>)
    * comply with extra and pedantic compiler flags
    * use c++11 nullptr instead of NULL
    * make ABI breaking change for explicit constructors
    * make linters happy
    * no need to support console_bridge < 0.3.0 anymore
    * remove obsolete todo
    * add virtual destructor in test
    * vector size() returns size_t
    * simplify branching
  * [fix warnings] c++11 requires at least one argument for ... (#71 <https://github.com/ros/class_loader/issues/71>)
  * [linter] Use std::string::empty instead comparing with an empty string (#69 <https://github.com/ros/class_loader/issues/69>)
  * [linter] wrap console bridge invocation lines (#68 <https://github.com/ros/class_loader/issues/68>)
  * OSRF and not willow in licence header (#67 <https://github.com/ros/class_loader/issues/67>)
  * Contributors: David Wagner, Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Thu, 15 Feb 2018 00:00:00 -0000

ros-one-class-loader (0.3.8-0noble) noble; urgency=high

  * Fix console_bridge marcos definition (#66 <https://github.com/ros/class_loader/issues/66>)
  * Style overhaul (#64 <https://github.com/ros/class_loader/issues/64>) (#62 <https://github.com/ros/class_loader/issues/62>)
  * Add copyright notice to unique_ptr_test.cpp (#65 <https://github.com/ros/class_loader/issues/65>)
  * Contributors: Maarten de Vries, Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Thu, 16 Nov 2017 00:00:00 -0000

ros-one-class-loader (0.3.7-0noble) noble; urgency=high

  * switch to package format 2 (#56 <https://github.com/ros/class_loader/issues/56>)
  * remove trailing whitespaces (#55 <https://github.com/ros/class_loader/issues/55>)
  * use CONSOLE_BRIDGE_X logging macros (#52 <https://github.com/ros/class_loader/issues/52>)
  * Contributors: Mikael Arguedas, jmachowinski

 -- Michael Carroll <michael@openrobotics.org>  Thu, 27 Jul 2017 00:00:00 -0000

ros-one-class-loader (0.3.6-0noble) noble; urgency=high

  * Made changes to two locking mechanisms inside class loader core's loadLibrary() function: 1) I added a lock to the 'addClassLoaderOwnerFor...' function to protect it against a race condition with the unloadLibrary() function. 2) I also raised the loader lock to cover the whole function. Previously the check to see if a library is already loaded and the actual loading of the library was not atomic. Multiple threads could create shared library objects, for example.


=== debian/control ===
Source: ros-one-class-loader
Section: misc
Priority: optional
Maintainer: Michael Carroll <michael@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libboost-filesystem-dev, libboost-system-dev, libboost-thread-dev, libconsole-bridge-dev, libpoco-dev, ros-one-catkin (>= 0.5.68), ros-one-cmake-modules (>= 0.3.3)
Homepage: http://ros.org/wiki/class_loader
Standards-Version: 3.9.2

Package: ros-one-class-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-filesystem-dev, libboost-system-dev, libboost-thread-dev, libconsole-bridge-dev, libpoco-dev
Description: The class_loader package is a ROS-independent package for loading plugins during runtime and the foundation of the higher level ROS &quot;pluginlib&quot; library.
 class_loader utilizes the host operating system's runtime loader to open runtime libraries (e.g. .so/.dll files), introspect the library for exported plugin classes, and allows users to instantiate objects of said exported classes without the explicit declaration (i.e. header file) for those classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-class-loader//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
